/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package photostrip;

import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author joshy
 */
public class PhotoStream {
    
    public static List<PhotoResource> parse(URL url) throws ParserConfigurationException, SAXException, XPathExpressionException, IOException {
        DocumentBuilderFactory fact = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = fact.newDocumentBuilder();
        Document doc = builder.parse(url.openStream());
        XPathFactory xpfact = XPathFactory.newInstance();
        XPath xp = xpfact.newXPath();
        NodeList list = (NodeList) xp.evaluate("/feed/entry", doc, XPathConstants.NODESET);
        
        List<PhotoResource> photos = new ArrayList<PhotoResource>();
        for(int i=0; i < list.getLength(); i++) {
            Element entry = (Element) list.item(i);
            
            NodeList feedNode = entry.getElementsByTagName("link");
            Element link = (Element) feedNode.item(0);
            String pageUrl = link.getAttribute("href");
                    
            Node contentNode = entry.getElementsByTagName("content").item(0);
            String content = contentNode.getTextContent();
            List<String> results = extract("src=\"(.*?)\"", content);
            p("image = " + results.get(1));
            photos.add(new PhotoResource(results.get(1),pageUrl));
        }
        return photos;
    }

    private static List<String> extract(String string, String content) {
        Pattern pattern = Pattern.compile(string);
        Matcher matcher = pattern.matcher(content);
        matcher.find();
        List<String> results = new ArrayList<String>();
        for(int i=0; i<=matcher.groupCount(); i++) {
            results.add(matcher.group(i));
        }
        return results;
    }

    private static void p(String string) {
        System.out.println(string);
    }
}
